

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""


   variable index 0
   variable selected 0

           set selected 0
           for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
               if {[set ::VMEConfig::ModuleType($i)] != ""} {set selected [expr $selected | (1 << $i)]}
           }


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"
   }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }
  
      proc do_Save {} {
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::NumModules
      
        InsertLog "Saving VME settings"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             switch [set ::VMEConfig::ModuleName($i)] {
                 v785#1  {::V785::do_Save}
                 v775#1  {::V775::do_Save}
                 v1724#1 {::V1724::do_Save}
                 v560#1  {::V560::do_Save}
                 v830#1  {::V830::do_Save}
                 sac#1   {}
                 default {}
             }
          }

        InsertLog "Done"

        Elog INFORMATION "VME settings saved"
    }

      proc do_Restore {} {
        variable selected
        variable ::VMEConfig::ModuleName
        variable ::VMEConfig::NumModules
      
        InsertLog "Restoring VME settings"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             switch [set ::VMEConfig::ModuleName($i)] {
                 v785#1  {::V785::do_Restore}
                 v775#1  {::V775::do_Restore}
                 v1724#1 {::V1724::do_Restore}
                 v560#1  {::V560::do_Restore}
                 v830#1  {::V830::do_Restore}
                 sac#1   {::SAC::do_Restore}
                 default {}
             }
          }

        InsertLog "Done"

       ::VMEConfig::WriteRegister HasBeenRestored 1

        Elog INFORMATION "VME settings restored"
    }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

