

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchannels 0

    variable ModuleName v1724
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable DPPEnable 1

   source [file join V1724 Registers.tcl]
 

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc do_RegisterHelp {W} {
      variable [set W]Register

        set Txtfile [file join V1724 [set [set W]Register].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable allchannels

        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable MRegister
        variable ChRegister
        variable DPPEnable
        variable Rmsg
        variable Wmsg

             InsertLog "DPPEnable=$DPPEnable"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag "
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "MRegister=$MRegister; ChRegister=$ChRegister"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
           InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
           InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

    proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_SelectModuleRegister {w} {
        variable MRegister
        variable MRegisterItem

        switch $w {
           "Channel Enable Mask"        {set MRegister ChEnable}
           "Trigger Source Enable Mask" {set MRegister TrigSrcEnable}
           "Front Panel Trigger Out Enable Mask" {set MRegister FPTrigEnable}
           "Analog Monitor"             {set MRegister AnalogMon}
           "Front Panel I/O Control"    {set MRegister FPIOCtrl}
           "Configuration"              {set MRegister CONFIGURATION}
           "Buffer Organisation"        {set MRegister BUFF_ORG}
           "Acquisition Window"         {set MRegister CUST_SIZE}
           "Acquisition Control"        {set MRegister AcqCtrl}
           "Acquisition Status"         {set MRegister AcqStatus}

           default  {set MRegister $w}
        }

        set MRegisterItem "$w"
   }

   proc do_SelectChannelRegister {w} {
        variable ChRegister
        variable ChRegisterItem

        switch $w {
           "Post Trigger Window"        {set ChRegister ChPostTrig}

           default  {set ChRegister $w}
        }

        set ChRegisterItem "$w"
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "$w = $v"}

        switch -glob $w {
            "Buffer Organisation" -
            BUFF_ORG        {WriteRegister BufferOrg $v}
            "Acquisition Window" -
            CUST_SIZE       {WriteRegister CustomSize $v}
            CHENABLE*       {WriteBitRegister ChEnable [string range $w 8 end] $v}
            TRIGSRCENABLE*  {WriteBitRegister TrigSrcEnable [string range $w 13 end] $v}
            FPTRIGENABLE*   {WriteBitRegister FPTrigOutEnable [string range $w 12 end] $v}
            ANALOGMON*      {WriteBitRegister AnalogMon [string range $w 9 end] $v}
            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}
            AcqControl -
            Clear -
            SoftTrig        {WriteRegister $w $v}
            CONFIGURATION.* {set $w $v; do_SetModuleConfig}
            FPIO*           {set $w $v; do_SetFPIO}
            AcqCtrl*        {set $w $v; do_SetAcqCtrl}
            AcqStatus*      {}

            default {set $w $v}
        }
   }

    proc do_UpdateModuleRegisters {} {

       variable BUFF_ORG; set BUFF_ORG [ReadRegister BufferOrg]
       variable CUST_SIZE; set CUST_SIZE [ReadRegister CustomSize]
       variable CHENABLE; set CHENABLE [ReadRegister ChEnable]
       variable TRIGSRCENABLE; set TRIGSRCENABLE [ReadRegister TrigSrcEnable]
       variable FPTRIGENABLE; set FPTRIGENABLE [ReadRegister FPTrigOutEnable]
       variable ANALOGMON; set ANALOGMON [ReadRegister AnalogMon]
       variable CONFIGURATION; set CONFIGURATION [ReadRegister ChConfig]; do_GetModuleConfig
       variable FPIO; set FPIO [ReadRegister FPIOControl]; do_GetFPIO
       variable AcqCtrl; set AcqCtrl [ReadRegister AcqControl]; do_GetAcqCtrl
       variable AcqStatus; set AcqStatus [ReadRegister AcqStatus]; do_GetAcqStatus
   }

   proc do_GetModuleConfig {} {
       variable CONFIGURATION
       variable CONFIGURATION.DualTrace
       variable CONFIGURATION.InvertInput
       variable CONFIGURATION.TrigMode
       variable CONFIGURATION.TrigOlap
       variable CONFIGURATION.TestMode
       variable CONFIGURATION.VProbe1
       variable CONFIGURATION.VProbe2
       variable CONFIGURATION.OscMode
       variable CONFIGURATION.EnergyMode
       variable CONFIGURATION.TimeTagMode
       variable CONFIGURATION.DigVProbe

       set CONFIGURATION.TrigOlap [expr ($CONFIGURATION >> 1) & 1]
       set CONFIGURATION.TestMode [expr ($CONFIGURATION >> 3) & 1]
       set CONFIGURATION.TrigMode [expr ($CONFIGURATION >> 8) & 1]
       set CONFIGURATION.InvertInput [expr ($CONFIGURATION >> 9) & 1]
       set CONFIGURATION.DualTrace [expr ($CONFIGURATION >> 11) & 1]
       set CONFIGURATION.VProbe1 [expr ($CONFIGURATION >> 12) & 3]
       set CONFIGURATION.VProbe2 [expr ($CONFIGURATION >> 14) & 3]
       set CONFIGURATION.OscMode [expr ($CONFIGURATION >> 16) & 1]
       set CONFIGURATION.EnergyMode [expr ($CONFIGURATION >> 17) & 1]
       set CONFIGURATION.TimeTagMode [expr ($CONFIGURATION >> 18) & 1]
       set CONFIGURATION.DigVProbe [expr ($CONFIGURATION >> 20) & 7]
   }

   proc do_SetModuleConfig {} {
       variable CONFIGURATION
       variable CONFIGURATION.DualTrace
       variable CONFIGURATION.InvertInput
       variable CONFIGURATION.TrigMode
       variable CONFIGURATION.TrigOlap
       variable CONFIGURATION.TestMode
       variable CONFIGURATION.VProbe1
       variable CONFIGURATION.VProbe2
       variable CONFIGURATION.OscMode
       variable CONFIGURATION.EnergyMode
       variable CONFIGURATION.TimeTagMode
       variable CONFIGURATION.DigVProbe

       set CONFIGURATION [expr ([set CONFIGURATION.TrigOlap] << 1) + \
                               ([set CONFIGURATION.TestMode] << 3) + \
                               (1 << 4) + \
                               ([set CONFIGURATION.TrigMode] << 8) + \
                               ([set CONFIGURATION.InvertInput] << 9) + \
                               ([set CONFIGURATION.DualTrace] << 11) + \
                               ([set CONFIGURATION.VProbe1] << 12) + \
                               ([set CONFIGURATION.VProbe2] << 14) + \
                               ([set CONFIGURATION.OscMode] << 16) + \
                               ([set CONFIGURATION.EnergyMode] << 17) + \
                               ([set CONFIGURATION.TimeTagMode] << 18) + \
                               ([set CONFIGURATION.DigVProbe] << 20)]

       WriteRegister ChConfig $CONFIGURATION
   }

   proc do_GetFPIO {} {
      variable FPIO 
      variable FPIO.B15 
      variable FPIO.B14 
      variable FPIO.B6 
      variable FPIO.B5 
      variable FPIO.B4 
      variable FPIO.B3 
      variable FPIO.B2 
      variable FPIO.B1 
      variable FPIO.B0

       set FPIO.B0 [expr $FPIO & 1]
       set FPIO.B1 [expr ($FPIO >> 1) & 1]
       set FPIO.B2 [expr ($FPIO >> 2) & 1]
       set FPIO.B3 [expr ($FPIO >> 3) & 1]
       set FPIO.B4 [expr ($FPIO >> 4) & 1]
       set FPIO.B5 [expr ($FPIO >> 5) & 1]
       set FPIO.B6 [expr ($FPIO >> 6) & 3]
       set FPIO.B14 [expr ($FPIO >> 14) & 1]       
       set FPIO.B15 [expr ($FPIO >> 15) & 1]
    }

   proc do_SetFPIO {} {
      variable FPIO 
      variable FPIO.B15 
      variable FPIO.B14 
      variable FPIO.B6 
      variable FPIO.B5 
      variable FPIO.B4 
      variable FPIO.B3 
      variable FPIO.B2 
      variable FPIO.B1 
      variable FPIO.B0

      set FPIO [expr ([set FPIO.B15] << 15) | \
                     ([set FPIO.B14] << 14) | \
                     ([set FPIO.B6] << 6) | \
                     ([set FPIO.B5] << 5) | \
                     ([set FPIO.B4] << 4) | \
                     ([set FPIO.B3] << 3) | \
                     ([set FPIO.B2] << 2) | \
                     ([set FPIO.B1] << 1) | \
                     ([set FPIO.B0])]

     WriteRegister FPIOControl $FPIO
   }

   proc do_GetAcqCtrl {} {
      variable AcqCtrl 
      variable AcqCtrl.B5
      variable AcqCtrl.B4
      variable AcqCtrl.B3
      variable AcqCtrl.B2
      variable AcqCtrl.B0

       set AcqCtrl.B0 [expr $AcqCtrl & 3]
       set AcqCtrl.B2 [expr ($AcqCtrl >> 2) & 1]
       set AcqCtrl.B3 [expr ($AcqCtrl >> 3) & 1]
       set AcqCtrl.B4 [expr ($AcqCtrl >> 4) & 1]
       set AcqCtrl.B5 [expr ($AcqCtrl >> 5) & 1]
    }

   proc do_SetAcqCtrl {} {
      variable AcqCtrl
      variable AcqCtrl.B5 
      variable AcqCtrl.B4 
      variable AcqCtrl.B3 
      variable AcqCtrl.B2 
      variable AcqCtrl.B0

      set AcqCtrl [expr ([set AcqCtrl.B5] << 5) | \
                     ([set AcqCtrl.B4] << 4) | \
                     ([set AcqCtrl.B3] << 3) | \
                     ([set AcqCtrl.B2] << 2) | \
                     ([set AcqCtrl.B0])]

     WriteRegister AcqControl $AcqCtrl
   }

   proc do_GetAcqStatus {} {
      variable AcqStatus
      variable AcqStatus.B8
      variable AcqStatus.B7
      variable AcqStatus.B6
      variable AcqStatus.B5
      variable AcqStatus.B4
      variable AcqStatus.B3
      variable AcqStatus.B2


       set AcqStatus.B2 [expr ($AcqStatus >> 2) & 1]
       set AcqStatus.B3 [expr ($AcqStatus >> 3) & 1]
       set AcqStatus.B4 [expr ($AcqStatus >> 4) & 1]
       set AcqStatus.B5 [expr ($AcqStatus >> 5) & 1]
       set AcqStatus.B6 [expr ($AcqStatus >> 6) & 1]
       set AcqStatus.B7 [expr ($AcqStatus >> 7) & 1]
       set AcqStatus.B8 [expr ($AcqStatus >> 8) & 1]
    }

proc handlePostTrig {v} {      ;# until firmware fixed 
    variable allchannels

# {if {$allchannels} {WriteRegister ChPostTrig $v} else {WriteRegister ChPostTrig$i $v}}

     WriteRegister ChPostTrig $v

       for {set i 0} {$i < 8} {incr i} {
           variable POSTTRG.Value$i ; set POSTTRG.Value$i $v
       }

}

    proc do_SetChannelRegister {w i v} {
        variable allchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "$w.$i = $v"}

        switch -glob $w {
            POSTTRG   {handlePostTrig $v}
            DAC       {if {$allchannels} {WriteRegister ChDAC $v}      else {WriteRegister ChDAC$i $v}}
            DPP_PAR1  {if {$allchannels} {WriteRegister ChDPP_PAR1 $v} else {WriteRegister ChDPP_PAR1$i $v}}
            DPP_PAR2  {if {$allchannels} {WriteRegister ChDPP_PAR2 $v} else {WriteRegister ChDPP_PAR2$i $v}}
            DPP_PAR3  {if {$allchannels} {WriteRegister ChDPP_PAR3 $v} else {WriteRegister ChDPP_PAR3$i $v}}
            DPP_PAR4  {if {$allchannels} {WriteRegister ChDPP_PAR4 $v} else {WriteRegister ChDPP_PAR4$i $v}}
            default {}
        }
   }

    proc do_UpdateChannelRegisters {} {

       for {set i 0} {$i < 8} {incr i} {
           variable DAC.Value$i ; set DAC.Value$i [ReadRegister ChDAC$i]
#           variable POSTTRG.Value$i ; set POSTTRG.Value$i [expr 8191 & [ReadRegister ChPostTrig$i]]
           variable OCCUPANCY.Value$i ; set OCCUPANCY.Value$i [ReadRegister ChBufs$i]

           variable STATUS.BufferFreeErr$i
           variable STATUS.CHn+1Enabled$i
           variable STATUS.CHnEnabled$i
           variable STATUS.DACBusy$i
           variable STATUS.MemEmpty$i
           variable STATUS.MemFull$i

           set STATUS [ReadRegister ChStatus$i]
           
           set STATUS.BufferFreeErr$i [expr ($STATUS >> 5) & 1]
           set STATUS.CHn+1Enabled$i [expr ($STATUS >> 4) & 1]
           set STATUS.CHnEnabled$i [expr ($STATUS >> 3) & 1]
           set STATUS.DACBusy$i [expr ($STATUS >> 2) & 1]
           set STATUS.MemEmpty$i [expr ($STATUS >> 1) & 1]
           set STATUS.MemFull$i [expr $STATUS & 1]

           variable DPP_PAR1.Value$i
           variable DPP_PAR1.RiseTime$i
           variable DPP_PAR1.AveragingWindow$i
           variable DPP_PAR1.DecayTime$i

           set PAR1 [ReadRegister ChDPP_PAR1$i]

           set DPP_PAR1.Value$i $PAR1
           set DPP_PAR1.RiseTime$i [expr $PAR1 & 0xff]
           set DPP_PAR1.AveragingWindow$i [expr ($PAR1 >> 8) & 0x3f]
           set DPP_PAR1.DecayTime$i [expr ($PAR1 >> 16) & 0x0000ffff]

           variable DPP_PAR2.Value$i
           variable DPP_PAR2.TrapezoidRiseTime$i
           variable DPP_PAR2.TrapezoidFlatTop$i
           variable DPP_PAR2.PeakValue2Divider$i
           variable DPP_PAR2.BaseLineMean$i

           set PAR2 [ReadRegister ChDPP_PAR2$i]

           set DPP_PAR2.Value$i $PAR2
           set DPP_PAR2.TrapezoidRiseTime$i [expr $PAR2 & 0x3ff]
           set DPP_PAR2.TrapezoidFlatTop$i [expr ($PAR2 >> 12) & 0x3ff]
           set DPP_PAR2.PeakValue2Divider$i [expr ($PAR2 >> 24) & 0x3f]
           set DPP_PAR2.BaseLineMean$i [expr ($PAR2 >> 30) & 0x3]

           variable DPP_PAR3.Value$i
           variable DPP_PAR3.Threshold$i
           variable DPP_PAR3.Decimation$i
           variable DPP_PAR3.FlatTopDelay$i
           variable DPP_PAR3.PeakAvWindow$i
           variable DPP_PAR3.DigitalGain$i

           set PAR3 [ReadRegister ChDPP_PAR3$i]

           set DPP_PAR3.Value$i $PAR3
           set DPP_PAR3.Threshold$i [expr $PAR3 & 0x3fff]
           set DPP_PAR3.Decimation$i [expr ($PAR3 >> 14) & 0x3]
           set DPP_PAR3.FlatTopDelay$i [expr ($PAR3 >> 16) & 0x7ff]
           set DPP_PAR3.PeakAvWindow$i [expr ($PAR3 >> 28) & 0x3]
           set DPP_PAR3.DigitalGain$i [expr ($PAR3 >> 30) & 0x3]

           variable DPP_PAR4.Value$i
           variable DPP_PAR4.TrigWinWidth$i
           variable DPP_PAR4.TrigWinOffset$i

           set PAR4 [ReadRegister ChDPP_PAR4$i]

           set DPP_PAR4.Value$i $PAR4
           set DPP_PAR4.TrigWinOffset$i [expr $PAR4 & 0x1ff]
           set DPP_PAR4.TrigWinWidth$i [expr (($PAR4 >> 9) & 0x7) * 16]
       }
 
   }

   proc do_SetDPPparameter {w s vl} {
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "SetDPPparameter $w $s $vl"}

       switch $w {

           DPP_PAR1 {
               set Ch [expr $s & 7]
               variable DPP_PAR1.RiseTime$Ch
               variable DPP_PAR1.AveragingWindow$Ch
               variable DPP_PAR1.DecayTime$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR1.RiseTime$Ch $vl}
               if {$id == 1} {set DPP_PAR1.AveragingWindow$Ch $vl}
               if {$id == 2} {set DPP_PAR1.DecayTime$Ch $vl}
               set Reg [expr [set DPP_PAR1.RiseTime$Ch] | \
                           ([set DPP_PAR1.AveragingWindow$Ch] << 8) | \
                           ([set DPP_PAR1.DecayTime$Ch] << 16)]
           }
           DPP_PAR2 {
               set Ch [expr $s & 7]
               variable DPP_PAR2.TrapezoidRiseTime$Ch
               variable DPP_PAR2.TrapezoidFlatTop$Ch
               variable DPP_PAR2.PeakValue2Divider$Ch
               variable DPP_PAR2.BaseLineMean$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR2.TrapezoidRiseTime$Ch $vl}
               if {$id == 1} {set DPP_PAR2.TrapezoidFlatTop$Ch $vl}
               if {$id == 2} {set DPP_PAR2.PeakValue2Divider$Ch $vl}
               set Reg [expr [set DPP_PAR2.TrapezoidRiseTime$Ch] | \
                           ([set DPP_PAR2.TrapezoidFlatTop$Ch] << 12) | \
                           ([set DPP_PAR2.PeakValue2Divider$Ch] << 24)| \
                           ([set DPP_PAR2.BaseLineMean$Ch] << 30)]
           }
           DPP_PAR3 {
               set Ch [expr $s & 7]
               variable DPP_PAR3.Threshold$Ch
               variable DPP_PAR3.Decimation$Ch
               variable DPP_PAR3.FlatTopDelay$Ch
               variable DPP_PAR3.PeakAvWindow$Ch
               variable DPP_PAR3.DigitalGain$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR3.Threshold$Ch $vl}
               if {$id == 1} {set DPP_PAR3.FlatTopDelay$Ch $vl}               
               set Reg [expr [set DPP_PAR3.Threshold$Ch] | \
                           ([set DPP_PAR3.Decimation$Ch] << 14) | \
                           ([set DPP_PAR3.FlatTopDelay$Ch] << 16)| \
                           ([set DPP_PAR3.PeakAvWindow$Ch] << 28) | \
                           ([set DPP_PAR3.DigitalGain$Ch] << 30)]
           }
           DPP_PAR4 {
               set Ch [expr $s & 7]
               variable DPP_PAR4.TrigWinWidth$Ch
               variable DPP_PAR4.TrigWinOffset$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR4.TrigWinWidth$Ch $vl}
               if {$id == 1} {set DPP_PAR4.TrigWinOffset$Ch $vl}         
               set Reg [expr [set DPP_PAR4.TrigWinOffset$Ch] | \
                           (([set DPP_PAR4.TrigWinWidth$Ch]/16) << 9)]
           }
       }

       do_SetChannelRegister $w $Ch $Reg
   }
 
    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName

        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           DBSetValue ChEnable      [ReadRegister ChEnable]
           DBSetValue ChConfig      [ReadRegister ChConfig]
           DBSetValue BufferOrg     [ReadRegister BufferOrg]
           DBSetValue TrigSrcEnable [ReadRegister TrigSrcEnable]
           DBSetValue FPTrigOutEnable  [ReadRegister FPTrigOutEnable]
           DBSetValue FPIOControl   [ReadRegister FPIOControl]
           DBSetValue AcqControl    [ReadRegister AcqControl]
           DBSetValue CustomSize    [ReadRegister CustomSize]
           DBSetValue AnalogMon     [ReadRegister AnalogMon]

           for {set i 0} {$i < 8} {incr i} {
              DBSetValue ChDAC$i      [ReadRegister ChDAC$i]
              variable POSTTRG.Value$i; DBSetValue ChPostTrig$i [set POSTTRG.Value$i]
              DBSetValue ChDPP_PAR1$i [ReadRegister ChDPP_PAR1$i]
              DBSetValue ChDPP_PAR2$i [ReadRegister ChDPP_PAR2$i]
              DBSetValue ChDPP_PAR3$i [ReadRegister ChDPP_PAR3$i]
              DBSetValue ChDPP_PAR4$i [ReadRegister ChDPP_PAR4$i]
           }

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

        set allmodules 0
        set allchannels 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

        WriteRegister Reset 0   ;# software reset modules

           WriteRegister ChEnable      [DBGetValue ChEnable]
           WriteRegister ChConfig      [DBGetValue ChConfig]
           WriteRegister BufferOrg     [DBGetValue BufferOrg]
           WriteRegister TrigSrcEnable [DBGetValue TrigSrcEnable]
           WriteRegister FPTrigOutEnable  [DBGetValue FPTrigOutEnable]
           WriteRegister FPIOControl   [DBGetValue FPIOControl]
           WriteRegister AcqControl    [DBGetValue AcqControl]
           WriteRegister CustomSize    [DBGetValue CustomSize]
           WriteRegister AnalogMon     [DBGetValue AnalogMon]

           for {set i 0} {$i < 8} {incr i} {
              WriteRegister ChDAC$i      [DBGetValue ChDAC$i]
              variable POSTTRG.Value$i; handlePostTrig [DBGetValue ChPostTrig$i]
              WriteRegister ChDPP_PAR1$i [DBGetValue ChDPP_PAR1$i]
              WriteRegister ChDPP_PAR2$i [DBGetValue ChDPP_PAR2$i]
              WriteRegister ChDPP_PAR3$i [DBGetValue ChDPP_PAR3$i]
              WriteRegister ChDPP_PAR4$i [DBGetValue ChDPP_PAR4$i]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER     {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp M}

                   CHREGISTER    {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTINGS      {
                       do_SetModuleRegister [lindex $cgidata 3] [lindex $cgidata 5]
                    ;#   do_UpdateModuleRegisters
                   }

                   MSETTING      {
                       do_SetModuleRegister [lindex $w 1] [lindex $w 2]
                    ;#   do_UpdateModuleRegisters
                   }

                   ACTION {
                        switch [lindex $w 1] {
                           AcqStart {
                              WriteRegister BLTEventNum 1
                              WriteRegister Control 16
                              WriteRegister Clear 0
                              WriteRegister SoftwareSyncReset 0
                              WriteRegister AcqControl 4
                           }
                           AcqHalt {
                              WriteRegister AcqControl 0
                           }
                           default {}
                        }
                   }
 
                   DAC -
                   POSTTRG -
                   CHSETTING  {
                       do_SetChannelRegister [lindex $w 0] [lindex $w 1] [lindex $w 2]
                     ;#  do_UpdateChannelRegisters
                   }

                   DPPSETTING  {
                       set Reg [lindex $w 1]
                       set Ch [lindex $w 2]
                       variable $Reg$Ch
                       set $Reg$Ch [lindex $w 3]
                       do_SetDPPparameter [first [split $Reg .]] [expr $Ch + 0xf0] -1
                     ;#  do_UpdateChannelRegisters
                   }

                   DPP_PAR1 -
                   DPP_PAR2 -
                   DPP_PAR3 -
                   DPP_PAR4 {
                       do_SetDPPparameter [lindex $w 0] [lindex $w 1] [lindex $w 2]
                     ;#  do_UpdateChannelRegisters
                   }

                   PLLWRITEFLASH {PLLWriteFlash}
                   PLLREADFLASH  {PLLReadFlash}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

